/*
 * CS5App.java     Connect Four - Part 1
 *
 * Homework # 10
 * Problem  #  1
 *
 * Name(s):
 * Date:
 * Time spent:
 *
 * Comments:  
 * 
 *
 */

import java.awt.*;

class CS5App
{
    public static void main(String[] args)
    {
        H.pl("Welcome to Connect Four!");
		int nrows = H.ni("How many rows would you like?");
		int ncols = H.ni("How many cols would you like?");
		H.pl("\n\n");
		
		Board b = new Board(nrows, ncols);
		
		// uncomment these three lines for graphical interface
		// GrCanvas C = G.createCanvas();
		// GrCFour CF = new GrCFour(b.getData());
		// C.add(CF);
		
		char player = 'X';
		int uc = 0;
		
		while (true)
		{
            b.print();
            // uncomment the following line to update the gui window
            // C.repaint();
            
			uc = H.ni(player + "'s move:");
			while ( !b.allowsMove(uc) )
			{
                uc = H.ni(player + "'s move:");
			}

			// add the move to the board
			b.addMove(uc,player);
			
			if (b.winsFor(player))
			{
			    b.print();
                // uncomment the following line to update the gui window
                // C.repaint();
				H.pl("\n\nPlayer " + player + " wins! Congratulations!");
				break;
			}
			
			if (b.isFull())
			{
			    b.print();
                // uncomment the following line to update the gui window
                // C.repaint();
				H.pl("\n\nThe board is full and the game is a draw!");
				break;
			}
			
			// swap the player
			if (player == 'X')
			    player = 'O';
			else
			    player = 'X';
		}
		
		H.pl("\n\n");
	}
} // end of CS5App class



/*
 * The Board class represents a connect-four board of almost arbitrary size
 */
class Board
{
	private int nrows;
	private int ncols;
	private char[][] data;
	
	/* Board constructor
	 * inputs: number of rows and number of columns
	 */
	public Board(int nr, int nc)
	{
		this.data = new char[nr][nc];
		nrows = data.length;
		ncols = data[0].length;
		
		for (int r=0 ; r<nrows ; ++r)
			for (int c=0 ; c<ncols ; ++c)
				data[r][c] = ' ';   // spaces to start
	}
	
	/* getData method -- returns the underlying board representation
	 * inputs: none
	 * outputs: a 2d array of chars: 'X' 'O' or ' '
	 */
	public char[][] getData()
	{
		return data;
	}
	
	/* print method -- prints the board that calls it to the console
	 * inputs: none
	 * outputs: none
	 */
	public void print()
	{
		for (int r=0 ; r<nrows ; ++r)
		{
			for (int c=0 ; c<ncols ; ++c)
			{
				H.p("|" + data[r][c]);
			}
			H.pl("|");
		}
		
		for (int c=0 ; c<ncols ; ++c)
		{
			H.p("--");
		}
		H.pl("-");
		
		for (int c=0 ; c<ncols ; ++c)
		{
			H.p(" "+(c%10));
		}
		H.pl("\n\n");
	}
	
	/* addMove -- adds a move to column c for player
	 * inputs: the column to move to (c) and the char to put there (player)
	 * outputs: none
	 */
	public void addMove(int c, char player)
	{
		if (this.allowsMove(c))
		{
			int r = nrows-1;
			while (data[r][c] != ' ')
			{
				--r;
			}
			data[r][c] = player;
		}
	}
	
	/* allowsMove -- determines if a move is allowed to column c
	 * inputs: the column to check (c)
	 * outputs: true if a player can move to c, false otherwise
	 */
	/* NOTE: you will need to fix this code
	 *       the code here is only to allow it to compile!
	 */
	public boolean allowsMove(int c)
	{
		return true;
	}
	
    /* isFull -- determines if this Board is full
     * inputs: none
     * outputs: true if the board is full, false otherwise
     */
    /* NOTE: you will need to fix this code
     *       the code here is only to allow it to compile!
     */ 
	public boolean isFull()
	{
        return false;
	}
	
    /* winsFor -- determines if this Board wins for a 
     * inputs: the char representing the player
     * outputs: true if the board is full, false otherwise
     */
    /* NOTE: you will need to fix this code
     *       the code here is only to allow it to compile!
     */
	public boolean winsFor(char player)
	{
		return false;	
	}
	
	
} // end of the Board class

